<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.member_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/party/member";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "",
              prop: "name",
              rules: [{
                required: true,
                message: "请输入",
                trigger: "blur"
              }]
            },
            {
              label: "性别： 0-未定义 1-男 2-女",
              prop: "sex",
              rules: [{
                required: true,
                message: "请输入性别： 0-未定义 1-男 2-女",
                trigger: "blur"
              }]
            },
            {
              label: "联系方式",
              prop: "phone",
              rules: [{
                required: true,
                message: "请输入联系方式",
                trigger: "blur"
              }]
            },
            {
              label: "住址",
              prop: "address",
              rules: [{
                required: true,
                message: "请输入住址",
                trigger: "blur"
              }]
            },
            {
              label: "身份证",
              prop: "idCard",
              rules: [{
                required: true,
                message: "请输入身份证",
                trigger: "blur"
              }]
            },
            {
              label: "所属党支部id",
              prop: "branchId",
              rules: [{
                required: true,
                message: "请输入所属党支部id",
                trigger: "blur"
              }]
            },
            {
              label: "党员状态：1-正常 2-转出 3-失联 4-死亡 5-清退",
              prop: "memberStatus",
              rules: [{
                required: true,
                message: "请输入党员状态：1-正常 2-转出 3-失联 4-死亡 5-清退",
                trigger: "blur"
              }]
            },
            {
              label: "入党时间",
              prop: "enterTime",
              rules: [{
                required: true,
                message: "请输入入党时间",
                trigger: "blur"
              }]
            },
            {
              label: "党员证件图像",
              prop: "memberPic",
              rules: [{
                required: true,
                message: "请输入党员证件图像",
                trigger: "blur"
              }]
            },
            {
              label: "是否为优秀党员： 1-是 0-否",
              prop: "isExcellent",
              rules: [{
                required: true,
                message: "请输入是否为优秀党员： 1-是 0-否",
                trigger: "blur"
              }]
            },
            {
              label: "审核状态  -1:审核不通过  0:待审核 1:审核通过",
              prop: "auditStatus",
              rules: [{
                required: true,
                message: "请输入审核状态  -1:审核不通过  0:待审核 1:审核通过",
                trigger: "blur"
              }]
            },
            {
              label: "审核意见",
              prop: "auditOpinion",
              rules: [{
                required: true,
                message: "请输入审核意见",
                trigger: "blur"
              }]
            },
            {
              label: "机构路径",
              prop: "orgPosition",
              rules: [{
                required: true,
                message: "请输入机构路径",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.member_add, false),
          viewBtn: this.vaildData(this.permission.member_view, false),
          delBtn: this.vaildData(this.permission.member_delete, false),
          editBtn: this.vaildData(this.permission.member_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
